/// <reference types="node" />
import { CID } from 'multiformats/cid';
import { Buffer } from 'buffer';
import { Stack } from './stack';
export declare enum ShardKind {
    Binary = "binary",
    Object = "object"
}
export declare class Shard<TData = Buffer | Record<string, any>> {
    stack: Stack;
    cid: CID;
    kind: ShardKind;
    data: TData;
    private events;
    private constructor();
    put(data: TData): Promise<void>;
    on(event: 'update', listener: (shard: Shard<TData>) => void): void;
    static new<TData = unknown>(stack: Stack, kind: ShardKind, data: TData): Promise<Shard<TData>>;
    static create<TData = Buffer | Record<string, any>>(stack: Stack, cid: CID, kind: ShardKind): Promise<Shard<TData>>;
    static from<TData = Buffer | Record<string, any>>(stack: Stack, path: string): Promise<Shard<TData>>;
    toString(): string;
}
