import { Shard } from './shard';
import { Stack } from './stack';
export interface ReplicateMessage {
    kind: 'replicate';
    key: string;
    value: string;
    date: string;
}
export interface ReplicateRequestMessage {
    kind: 'replicateRequest';
}
export declare type StackMessage = ReplicateMessage | ReplicateRequestMessage;
export declare class Store {
    private stack;
    private pubsub;
    private data;
    constructor(stack: Stack);
    private onReplicate;
    private watchShard;
    get<TData = unknown>(key: string): Promise<Shard<TData> | null>;
    set<TData = unknown>(key: string, shard: Shard<TData>): Promise<void>;
    private replicate;
    start(): Promise<void>;
    stop(): Promise<void>;
}
